import psycopg2
import graph_tool.all as gt
import os
remConn = psycopg2.connect("dbname=" + os.environ["RP_DBNAME"] + " user=" + os.environ["RP_USER"] + " password=" + os.environ["RP_PASSWORD"] + " host=" + os.environ["RP_HOST"])
remCur = remConn.cursor()
#Budeme postupne robit nove thready pre kazdy mesiac
def generateGraph():
	g = gt.Graph(directed=True)
	node_to_vertex={}
	vertex_to_node={}
	#Teraz nazbierat vsetky hrany
	remCur.execute("""SELECT t_route FROM topology WHERE t_status = 'C'""")
	if remCur.rowcount == 0: return
	
	existing_edges = set()

	# Add edges to the graph based on the routes
	for record in remCur:
		route = record[0]  # Assuming this is a list or tuple of node identifiers
		for i in range(len(route) - 1):
			src, dest = route[i], route[i + 1]
			if src not in node_to_vertex:
				newNode = g.add_vertex()
				node_to_vertex[src] = newNode
				vertex_to_node[newNode] = src
			if dest not in node_to_vertex:
				newNode = g.add_vertex()
				node_to_vertex[dest] = newNode
				vertex_to_node[newNode] = dest

			# Check if the edge already exists before adding
			if (src, dest) not in existing_edges:
				g.add_edge(node_to_vertex[src], node_to_vertex[dest])
				existing_edges.add((src, dest))

	# Use a layout algorithm to position the nodes
	pos = gt.radial_tree_layout(g, g.vertex(0))

	# Draw the graph
	#S IP adresami
	gt.graph_draw(g,
		pos,
		output_size=(10000, 10000),
		vertex_text=g.new_vertex_property('string', vals =[vertex_to_node[v] for v in g.vertices()]),
		vertex_font_size=7,
		vertex_size=5,
		edge_pen_width=1.0,
		bg_color=[1,1,1,1],
		output="all.png")
		
	#Bez textu	
	gt.graph_draw(g,
		pos,
		output_size=(10000, 10000),
		vertex_size=2,
		edge_pen_width=1.0,
		bg_color=[1,1,1,1],
		output="all_noips.png")
		
generateGraph()
# Close the database cursor and connection
remCur.close()
remConn.close()		

