import psycopg2
import datetime
import os
remConn = psycopg2.connect("dbname=" + os.environ["RP_DBNAME"] + " user=" + os.environ["RP_USER"] + " password=" + os.environ["RP_PASSWORD"] + " host=" + os.environ["RP_HOST"])
remCur = remConn.cursor()

for year in range(2009, 2022):
	for month in range(1, 12):
		if year == 2022 and month == 12: break
		with open(str(year) + '-' + str(month) + '.txt', "w") as o:
			thisMonth = datetime.datetime(year, month, 1)
			nextMonth = datetime.datetime(year, month + 1, 1)
			remCur.execute("""
					WITH t AS (SELECT UNNEST(t_route) FROM topology WHERE t_status = 'C' AND t_date >= '""" + thisMonth.strftime('%Y-%m-%d') + """' AND t_date < '""" + nextMonth.strftime('%Y-%m-%d') + """')
	SELECT DISTINCT unnest FROM t WHERE NOT(
	unnest <<= '0.0.0.0/8' OR unnest <<= '0.0.0.0/32' OR unnest <<= '10.0.0.0/8'
	OR unnest <<= '100.64.0.0/10' OR unnest <<= '127.0.0.0/8' OR unnest <<=
	'169.254.0.0/16' OR unnest <<= '172.16.0.0/12' OR unnest <<= '192.0.2.0/24' OR unnest <<= '192.88.99.0/24'
	OR unnest <<= '192.88.99.2/32' OR unnest <<= '192.168.0.0/16' OR unnest <<= '192.0.0.0/24'
	OR unnest <<= '198.18.0.0/15' OR unnest <<= '198.51.100.0/24' OR unnest <<= '203.0.113.0/24'
	OR unnest <<= '255.255.255.255/32'
	);
			""")
			for record in remCur:
				o.write(str(record) + '\n')
				
remCur.close()
remConn.close()
